#include "multithread.h"
#include <QTimer>
#include <QEventLoop>
#include "simplependulum.h"
#include <QThread>
#include <QDebug>
//SimplePendulum *pendulum;
MultiThread::MultiThread(QObject *parent) :
    QObject(parent)
{
    _working =false;
    _abort = false;
    //pendulum=new SimplePendulum;

}

void MultiThread::requestThread()
{
    mutex.lock();
    _working = true;
    _abort = false;
    qDebug()<<thread()->currentThreadId();
    mutex.unlock();

    emit multithreadRequested();
}

void MultiThread::abort()
{
    mutex.lock();
    if (_working) {
        _abort = true;
        qDebug()<<thread()->currentThreadId();
    }
    mutex.unlock();
}
void MultiThread::resume()
{
mutex.lock();
if(!_working)
{
_abort = true;
qDebug()<<thread()->currentThreadId();
}
mutex.unlock();
pauseContd.wakeAll();
emit resume();


}

void MultiThread::doMultiThread()
{
    qDebug()<<thread()->currentThreadId();
    long int iCounter=0;
    while(true)
    {
        iCounter++;
        int a=iCounter;
        if(a!=0)
        {
            emit value(a);

        }

        /*else if(a==3)
        {
            emit value(a);
        }
        else if(a==4)
        {
            emit value(a);
        }
        else if(a==5)
        {
            emit value(a);
        }
        else if(a==6)
        {
            emit value(a);
        }
        else if(a==7)
        {
            emit value(a);
        }
        else if(a==8)
        {
            emit value(a);
        }
        else if(a==9)
        {
            emit value(a);
        }*/
        mutex.lock();
        bool abort = _abort;
        mutex.unlock();

        if (abort)
        {
            qDebug()<<thread()->currentThreadId();
            break;
        }

        QEventLoop loop;
        QTimer::singleShot(1000, &loop, SLOT(quit()));
        loop.exec();
        emit valueChanged(QString::number(iCounter));
    }
mutex.lock();
_working = false;
mutex.unlock();

qDebug()<<thread()->currentThreadId();

emit finished();
}

